集训第五天(2017/8/4):刷搜索题

     今天就做了两道题,上午做了一道深搜题,下午做了一道广搜题,晚上又回顾了一下这两道题,虽然今天做的题不多,但是收获还是很大的,尤其是下午做的那道广搜题,让我对广搜有进一步了解。今上午做的那道深搜题感觉有点难,虽然能大体看懂题解但还是不能完全理解,先贴上那道bfs的题吧,我认为这道题很好的体现了广度优先搜索的思想。

 

Prime Path

Time Limit : 2000/1000ms (Java/Other)   Memory Limit : 131072/65536K (Java/Other)
Total Submission(s) : 69   Accepted Submission(s) : 30
Problem Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.  
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!  
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.  
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!  
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.  
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.  

Now, the minister of finance, who had been eavesdropping, intervened.  
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.  
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?  
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.  
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
 


 

Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
 


 

Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
 


 

Sample Input
  
  
3 1033 8179 1373 8017 1033 1033
 


 

Sample Output
  
  
6 7 0
 

 

#include<iostream>//c++语言实现
#include<queue>
#include<cmath>
#include<cstdio>
#include<cstring>
using namespace std;
int p[10000];//p[i]用来标记i是否是素数
bool pd(int n)
{int k;
    k=sqrt(n);
    for(int i=2;i<=k;i++)
      if(n%i==0)  return 0;
      return 1;
}
int turn(int n,int k)//把四位整数n的第k位转化为0,这种实现方法很巧妙!
{   char s[10];
memset(s,0,sizeof(s));
    sprintf(s,"%d",n);//把整数n作为字符串打印到s中
    s[k-1]='0';
    sscanf(s,"%4d",&n);//把s中前4个字符以整数形式拷贝到n中
    return n;
}
int bfs(int s,int e)
{   int x,i,j,k;
    int v[10000];
    memset(v,0,sizeof(v));//v[s]数组承担起两个作用,即用来判断s是否被用过也用来判断到s时的步数;当v[s]==0时,说明s还没被用过,步数为0,当v[s]==n时,n==起始值到s的实际步数+1。认为这是另一个巧妙的地方!
    queue<int>y;
    y.push(s);
    v[s]=1;
    while(y.size())
    {
        s=y.front();
        y.pop();
        if(s==e)
        return v[s]-1;
        int t=1000;
        for(k=1;k<=4;k++)
        {
          x=turn(s,k);
          for(i=0;i<=9;i++)
           {j=x+i*t;
           if(p[j]==1&&v[j]==0)//j是素数并且j没被用过
            {
                y.push(j);
               v[j]=v[s]+1;//这一层的步数==上一层的步数+1,体现广搜过程
            }
           }
           t/=10;
        }
    }
    return -1;
}
int main()
{
    int s,e,n;
    for(int h=1000;h<10000;h++)
    p[h]=pd(h);
    cin>>n;
    while(n--)
    {
        cin>>s>>e;
        int ans=bfs(s,e);
        if(ans==-1) cout<<"Impossible"<<endl;
        else cout<<ans<<endl;
    }

    return 0;
}

 

          

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值